import Controller from '@ember/controller';
import { computed } from '@ember/object';
import { A } from '@ember/array';
import EmberObject from '@ember/object';
import AuthorityValidations from "../../validations/authority";
import { task } from "ember-concurrency";

export default Controller.extend({
  isAddingEntry: false,
  newEntry: EmberObject.create({name: '',users: []}),
  
  AuthorityValidations,

	userList: computed('users', function() {
		this.store.findAll('user');
	}),

	name: null,
	users: null,
authorityTableColumns: computed(function() {
	var col = A([
		EmberObject.create({
			propertyName: "name",
			title: "name"
		})]);
	col.pushObject({
		title: 'Delete',
		component: 'delete-row'
	});
	return col;	}),
authorityTableContent: computed(function() {
	return this.get('authorities');
}),

  actions: {
    submit() {
      console.log("action submit");
    },
    deleteRecord (record) {
      console.log('record is '+ record);
      record.destroyRecord();
    }
  },
  submitEntry: task(function*(model) {
    yield model.save();
    let newEntity = this.store.createRecord('authority',yield model.get('data'));
    yield newEntity.save();
    console.log("new entry of id "+newEntity.get('id')+" created");
    this.set('addEntryModal', false);
  })
});